
/*
 * Janino - An embedded Java[TM] compiler
 * Copyright (C) 2001 Arno Unkrig
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Contact information:
 *   Arno Unkrig
 *   Ferdinand-Miller-Platz 10
 *   80335 Muenchen
 *   Germany
 *   http://www.janino.net
 *   maintainer@janino.net
 */

package net.janino;

/**
 * Definitions of Java bytecode opcodes.
 */

/*package*/ interface Opcode {
    final static String cvs_header = "$Header: /home/arno/cvsroot/JANINO/src/net/janino/Opcode.java,v 1.7 2002/05/02 22:03:18 arno Exp $";

    public final static byte AALOAD = 50;
    public final static byte AASTORE = 83;
    public final static byte ACONST_NULL = 1;
    public final static byte ALOAD = 25;
    public final static byte ALOAD_0 = 42;
    public final static byte ALOAD_1 = 43;
    public final static byte ALOAD_2 = 44;
    public final static byte ALOAD_3 = 45;
    public final static byte ANEWARRAY = (byte) 189;
    public final static byte ARETURN = (byte) 176;
    public final static byte ARRAYLENGTH = (byte) 190;
    public final static byte ASTORE = 58;
    public final static byte ASTORE_0 = 75;
    public final static byte ASTORE_1 = 76;
    public final static byte ASTORE_2 = 77;
    public final static byte ASTORE_3 = 78;
    public final static byte ATHROW = (byte) 191;
    public final static byte BALOAD = 51;
    public final static byte BASTORE = 84;
    public final static byte BIPUSH = 16;
    public final static byte CALOAD = 52;
    public final static byte CASTORE = 85;
    public final static byte CHECKCAST = (byte) 192;
    public final static byte D2F = (byte) 144;
    public final static byte D2I = (byte) 142;
    public final static byte D2L = (byte) 143;
    public final static byte DADD = 99;
    public final static byte DALOAD = 49;
    public final static byte DASTORE = 82;
    public final static byte DCMPG = (byte) 152;
    public final static byte DCMPL = (byte) 151;
    public final static byte DCONST_0 = 14;
    public final static byte DCONST_1 = 15;
    public final static byte DDIV = 111;
    public final static byte DLOAD = 24;
    public final static byte DLOAD_0 = 38;
    public final static byte DLOAD_1 = 39;
    public final static byte DLOAD_2 = 40;
    public final static byte DLOAD_3 = 41;
    public final static byte DMUL = 107;
    public final static byte DNEG = 119;
    public final static byte DREM = 115;
    public final static byte DRETURN = (byte) 175;
    public final static byte DSTORE = 57;
    public final static byte DSTORE_0 = 71;
    public final static byte DSTORE_1 = 72;
    public final static byte DSTORE_2 = 73;
    public final static byte DSTORE_3 = 74;
    public final static byte DSUB = 103;
    public final static byte DUP = 89;
    public final static byte DUP_X1 = 90;
    public final static byte DUP_X2 = 91;
    public final static byte DUP2 = 92;
    public final static byte DUP2_X1 = 93;
    public final static byte DUP2_X2 = 94;
    public final static byte F2D = (byte) 141;
    public final static byte F2I = (byte) 139;
    public final static byte F2L = (byte) 140;
    public final static byte FADD = 98;
    public final static byte FALOAD = 48;
    public final static byte FASTORE = 81;
    public final static byte FCMPG = (byte) 150;
    public final static byte FCMPL = (byte) 149;
    public final static byte FCONST_0 = 11;
    public final static byte FCONST_1 = 12;
    public final static byte FCONST_2 = 13;
    public final static byte FDIV = 110;
    public final static byte FLOAD = 23;
    public final static byte FLOAD_0 = 34;
    public final static byte FLOAD_1 = 35;
    public final static byte FLOAD_2 = 36;
    public final static byte FLOAD_3 = 37;
    public final static byte FMUL = 106;
    public final static byte FNEG = 118;
    public final static byte FREM = 114;
    public final static byte FRETURN = (byte) 174;
    public final static byte FSTORE = 56;
    public final static byte FSTORE_0 = 67;
    public final static byte FSTORE_1 = 68;
    public final static byte FSTORE_2 = 69;
    public final static byte FSTORE_3 = 70;
    public final static byte FSUB = 102;
    public final static byte GETFIELD = (byte) 180;
    public final static byte GETSTATIC = (byte) 178;
    public final static byte GOTO = (byte) 167;
    public final static byte GOTO_W = (byte) 200;
    public final static byte I2B = (byte) 145;
    public final static byte I2C = (byte) 146;
    public final static byte I2D = (byte) 135;
    public final static byte I2F = (byte) 134;
    public final static byte I2L = (byte) 133;
    public final static byte I2S = (byte) 147;
    public final static byte IADD = 96;
    public final static byte IALOAD = 46;
    public final static byte IAND = 126;
    public final static byte IASTORE = 79;
    public final static byte ICONST_M1 = 2;
    public final static byte ICONST_0 = 3;
    public final static byte ICONST_1 = 4;
    public final static byte ICONST_2 = 5;
    public final static byte ICONST_3 = 6;
    public final static byte ICONST_4 = 7;
    public final static byte ICONST_5 = 8;
    public final static byte IDIV = 108;
    public final static byte IF_ACMPEQ = (byte) 165;
    public final static byte IF_ACMPNE = (byte) 166;
    public final static byte IF_ICMPEQ = (byte) 159;
    public final static byte IF_ICMPNE = (byte) 160;
    public final static byte IF_ICMPLT = (byte) 161;
    public final static byte IF_ICMPGE = (byte) 162;
    public final static byte IF_ICMPGT = (byte) 163;
    public final static byte IF_ICMPLE = (byte) 164;
    public final static byte IFEQ = (byte) 153;
    public final static byte IFNE = (byte) 154;
    public final static byte IFLT = (byte) 155;
    public final static byte IFGE = (byte) 156;
    public final static byte IFGT = (byte) 157;
    public final static byte IFLE = (byte) 158;
    public final static byte IFNONNULL = (byte) 199;
    public final static byte IFNULL = (byte) 198;
    public final static byte IINC = (byte) 132;
    public final static byte ILOAD = 21;
    public final static byte ILOAD_0 = 26;
    public final static byte ILOAD_1 = 27;
    public final static byte ILOAD_2 = 28;
    public final static byte ILOAD_3 = 29;
    public final static byte IMUL = 104;
    public final static byte INEG = 116;
    public final static byte INSTANCEOF = (byte) 193;
    public final static byte INVOKEINTERFACE = (byte) 185;
    public final static byte INVOKESPECIAL = (byte) 183;
    public final static byte INVOKESTATIC = (byte) 184;
    public final static byte INVOKEVIRTUAL = (byte) 182;
    public final static byte IOR = (byte) 128;
    public final static byte IREM = 112;
    public final static byte IRETURN = (byte) 172;
    public final static byte ISHL = 120;
    public final static byte ISHR = 122;
    public final static byte ISTORE = 54;
    public final static byte ISTORE_0 = 59;
    public final static byte ISTORE_1 = 60;
    public final static byte ISTORE_2 = 61;
    public final static byte ISTORE_3 = 62;
    public final static byte ISUB = 100;
    public final static byte IUSHR = 124;
    public final static byte IXOR = (byte) 130;
    public final static byte JSR = (byte) 168;
    public final static byte JSR_W = (byte) 201;
    public final static byte L2D = (byte) 138;
    public final static byte L2F = (byte) 137;
    public final static byte L2I = (byte) 136;
    public final static byte LADD = 97;
    public final static byte LALOAD = 47;
    public final static byte LAND = 127;
    public final static byte LASTORE = 80;
    public final static byte LCMP = (byte) 148;
    public final static byte LCONST_0 = 9;
    public final static byte LCONST_1 = 10;
    public final static byte LDC = 18;
    public final static byte LDC_W = 19;
    public final static byte LDC2_W = 20;
    public final static byte LDIV = 109;
    public final static byte LLOAD = 22;
    public final static byte LLOAD_0 = 30;
    public final static byte LLOAD_1 = 31;
    public final static byte LLOAD_2 = 32;
    public final static byte LLOAD_3 = 33;
    public final static byte LMUL = 105;
    public final static byte LNEG = 117;
    public final static byte LOOKUPSWITCH = (byte) 171;
    public final static byte LOR = (byte) 129;
    public final static byte LREM = 113;
    public final static byte LRETURN = (byte) 173;
    public final static byte LSHL = 121;
    public final static byte LSHR = 123;
    public final static byte LSTORE = 55;
    public final static byte LSTORE_0 = 63;
    public final static byte LSTORE_1 = 64;
    public final static byte LSTORE_2 = 65;
    public final static byte LSTORE_3 = 66;
    public final static byte LSUB = 101;
    public final static byte LUSHR = 125;
    public final static byte LXOR = (byte) 131;
    public final static byte MONITORENTER = (byte) 194;
    public final static byte MONITOREXIT = (byte) 195;
    public final static byte MULTIANEWARRAY = (byte) 197;
    public final static byte NEW = (byte) 187;
    public final static byte NEWARRAY = (byte) 188;
    public final static byte NOP = 0;
    public final static byte POP = 87;
    public final static byte POP2 = 88;
    public final static byte PUTFIELD = (byte) 181;
    public final static byte PUTSTATIC = (byte) 179;
    public final static byte RET = (byte) 169;
    public final static byte RETURN = (byte) 177;
    public final static byte SALOAD = 53;
    public final static byte SASTORE = 86;
    public final static byte SIPUSH = 17;
    public final static byte SWAP = 95;
    public final static byte TABLESWITCH = (byte) 170;
    public final static byte WIDE = (byte) 196;

    /**
     * Constants for the "OPCODE_PROPERTIES" array.
     */
    public static final short INVALID_OPCODE = -1;

    // "Stack delta" constants.
    public static final short SD_MASK            = 31;
    public static final short SD_M4              = 0;
    public static final short SD_M3              = 1;
    public static final short SD_M2              = 2;
    public static final short SD_M1              = 3;
    public static final short SD_P0              = 4;
    public static final short SD_P1              = 5;
    public static final short SD_P2              = 6;
    public static final short SD_0               = 7;
    public static final short SD_1               = 8;
    public static final short SD_GETFIELD        = 9;
    public static final short SD_GETSTATIC       = 10;
    public static final short SD_PUTFIELD        = 11;
    public static final short SD_PUTSTATIC       = 12;
    public static final short SD_INVOKEVIRTUAL   = 13;
    public static final short SD_INVOKESPECIAL   = 14;
    public static final short SD_INVOKESTATIC    = 15;
    public static final short SD_INVOKEINTERFACE = 16;
    public static final short SD_MULTIANEWARRAY  = 18;

    // Operand 1 types.
    public static final short OP1_MASK         = 15 * 32;
    public static final short OP1_SB           =  1 * 32;
    public static final short OP1_UB           =  2 * 32;
    public static final short OP1_SS           =  3 * 32;
    public static final short OP1_CP1          =  4 * 32;
    public static final short OP1_CP2          =  5 * 32;
    public static final short OP1_LV1          =  6 * 32;
    public static final short OP1_LV2          =  7 * 32;
    public static final short OP1_BO2          =  8 * 32;
    public static final short OP1_BO4          =  9 * 32;
    public static final short OP1_LOOKUPSWITCH = 10 * 32;
    public static final short OP1_TABLESWITCH  = 11 * 32;
    public static final short OP1_JSR          = 12 * 32;

    // Operand 2 types.
    public static final short OP2_MASK = 3 * 512;
    public static final short OP2_SB   = 1 * 512;
    public static final short OP2_SS   = 2 * 512;

    // Operand 3 types.
    public static final short OP3_MASK = 1 * 2048;
    public static final short OP3_SB   = 1 * 2048;

    // Implicit operands.
    public static final short IO_MASK = 7 * 4096;
    public static final short IO_LV_0 = 1 * 4096;
    public static final short IO_LV_1 = 2 * 4096;
    public static final short IO_LV_2 = 3 * 4096;
    public static final short IO_LV_3 = 4 * 4096;

    public static final short NO_FALLTHROUGH = (short) 32768;

    public static final short[] OPCODE_PROPERTIES = {
/*  0*/ /*NOP*/             SD_P0,
        /*ACONST_NULL*/     SD_P1,
        /*ICONST_M1*/       SD_P1,
        /*ICONST_0*/        SD_P1,
        /*ICONST_1*/        SD_P1,
        /*ICONST_2*/        SD_P1,
        /*ICONST_3*/        SD_P1,
        /*ICONST_4*/        SD_P1,
        /*ICONST_5*/        SD_P1,
        /*LCONST_0*/        SD_P2,
/* 10*/ /*LCONST_1*/        SD_P2,
        /*FCONST_0*/        SD_P1,
        /*FCONST_1*/        SD_P1,
        /*FCONST_2*/        SD_P1,
        /*DCONST_0*/        SD_P2,
        /*DCONST_1*/        SD_P2,
        /*BIPUSH*/          SD_P1 | OP1_SB,
        /*SIPUSH*/          SD_P1 | OP1_SS,
        /*LDC*/             SD_P1 | OP1_CP1,
        /*LDC_W*/           SD_P1 | OP1_CP2,
/* 20*/ /*LDC2_W*/          SD_P2 | OP1_CP2,
        /*ILOAD*/           SD_P1 | OP1_LV1,
        /*LLOAD*/           SD_P2 | OP1_LV1,
        /*FLOAD*/           SD_M1 | OP1_LV1,
        /*DLOAD*/           SD_P2 | OP1_LV1,
        /*ALOAD*/           SD_P1 | OP1_LV1,
        /*ILOAD_0*/         SD_P1 | IO_LV_0,
        /*ILOAD_1*/         SD_P1 | IO_LV_1,
        /*ILOAD_2*/         SD_P1 | IO_LV_2,
        /*ILOAD_3*/         SD_P1 | IO_LV_3,
/* 30*/ /*LLOAD_0*/         SD_P2 | IO_LV_0,
        /*LLOAD_1*/         SD_P2 | IO_LV_1,
        /*LLOAD_2*/         SD_P2 | IO_LV_2,
        /*LLOAD_3*/         SD_P2 | IO_LV_3,
        /*FLOAD_0*/         SD_P1 | IO_LV_0,
        /*FLOAD_1*/         SD_P1 | IO_LV_1,
        /*FLOAD_2*/         SD_P1 | IO_LV_2,
        /*FLOAD_3*/         SD_P1 | IO_LV_3,
        /*DLOAD_0*/         SD_P2 | IO_LV_0,
        /*DLOAD_1*/         SD_P2 | IO_LV_1,
/* 40*/ /*DLOAD_2*/         SD_P2 | IO_LV_2,
        /*DLOAD_3*/         SD_P2 | IO_LV_3,
        /*ALOAD_0*/         SD_P1 | IO_LV_0,
        /*ALOAD_1*/         SD_P1 | IO_LV_1,
        /*ALOAD_2*/         SD_P1 | IO_LV_2,
        /*ALOAD_3*/         SD_P1 | IO_LV_3,
        /*IALOAD*/          SD_M1,
        /*LALOAD*/          SD_P0,
        /*FALOAD*/          SD_M1,
        /*DALOAD*/          SD_P0,
/* 50*/ /*AALOAD*/          SD_M1,
        /*BALOAD*/          SD_M1,
        /*CALOAD*/          SD_M1,
        /*SALOAD*/          SD_M1,
        /*ISTORE*/          SD_M1 | OP1_LV1,
        /*LSTORE*/          SD_M2 | OP1_LV1,
        /*FSTORE*/          SD_M1 | OP1_LV1,
        /*DSTORE*/          SD_M2 | OP1_LV1,
        /*ASTORE*/          SD_M1 | OP1_LV1,
        /*ISTORE_0*/        SD_M1 | IO_LV_0,
/* 60*/ /*ISTORE_1*/        SD_M1 | IO_LV_1,
        /*ISTORE_2*/        SD_M1 | IO_LV_2,
        /*ISTORE_3*/        SD_M1 | IO_LV_3,
        /*LSTORE_0*/        SD_M2 | IO_LV_0,
        /*LSTORE_1*/        SD_M2 | IO_LV_1,
        /*LSTORE_2*/        SD_M2 | IO_LV_2,
        /*LSTORE_3*/        SD_M2 | IO_LV_3,
        /*FSTORE_0*/        SD_M1 | IO_LV_0,
        /*FSTORE_1*/        SD_M1 | IO_LV_1,
        /*FSTORE_2*/        SD_M1 | IO_LV_2,
/* 70*/ /*FSTORE_3*/        SD_M1 | IO_LV_3,
        /*DSTORE_0*/        SD_M2 | IO_LV_0,
        /*DSTORE_1*/        SD_M2 | IO_LV_1,
        /*DSTORE_2*/        SD_M2 | IO_LV_2,
        /*DSTORE_3*/        SD_M2 | IO_LV_3,
        /*ASTORE_0*/        SD_M1 | IO_LV_0,
        /*ASTORE_1*/        SD_M1 | IO_LV_1,
        /*ASTORE_2*/        SD_M1 | IO_LV_2,
        /*ASTORE_3*/        SD_M1 | IO_LV_3,
        /*IASTORE*/         SD_M3,
/* 80*/ /*LASTORE*/         SD_M4,
        /*FASTORE*/         SD_M3,
        /*DASTORE*/         SD_M4,
        /*AASTORE*/         SD_M3,
        /*BASTORE*/         SD_M3,
        /*CASTORE*/         SD_M3,
        /*SASTORE*/         SD_M3,
        /*POP*/             SD_M1,
        /*POP2*/            SD_M2,
        /*DUP*/             SD_P1,
/* 90*/ /*DUP_X1*/          SD_P1,
        /*DUP_X2*/          SD_P1,
        /*DUP2*/            SD_P2,
        /*DUP2_X1*/         SD_P2,
        /*DUP2_X2*/         SD_P2,
        /*SWAP*/            SD_P0,
        /*IADD*/            SD_M1,
        /*LADD*/            SD_M2,
        /*FADD*/            SD_M1,
        /*DADD*/            SD_M2,
/*100*/ /*ISUB*/            SD_M1,
        /*LSUB*/            SD_M2,
        /*FSUB*/            SD_M1,
        /*DSUB*/            SD_M2,
        /*IMUL*/            SD_M1,
        /*LMUL*/            SD_M2,
        /*FMUL*/            SD_M1,
        /*DMUL*/            SD_M2,
        /*IDIV*/            SD_M1,
        /*LDIV*/            SD_M2,
/*110*/ /*FDIV*/            SD_M1,
        /*DDIV*/            SD_M2,
        /*IREM*/            SD_M1,
        /*LREM*/            SD_M2,
        /*FREM*/            SD_M1,
        /*DREM*/            SD_M2,
        /*INEG*/            SD_P0,
        /*LNEG*/            SD_P0,
        /*FNEG*/            SD_P0,
        /*DNEG*/            SD_P0,
/*120*/ /*ISHL*/            SD_M1,
        /*LSHL*/            SD_M1,
        /*ISHR*/            SD_M1,
        /*LSHR*/            SD_M1,
        /*IUSHR*/           SD_M1,
        /*LUSHR*/           SD_M1,
        /*IAND*/            SD_M1,
        /*LAND*/            SD_M2,
        /*IOR*/             SD_M1,
        /*LOR*/             SD_M2,
/*130*/ /*IXOR*/            SD_M1,
        /*LXOR*/            SD_M2,
        /*IINC*/            SD_P0 | OP1_LV1 | OP2_SB,
        /*I2L*/             SD_P1,
        /*I2F*/             SD_P0,
        /*I2D*/             SD_P1,
        /*L2I*/             SD_M1,
        /*L2F*/             SD_M1,
        /*L2D*/             SD_P0,
        /*F2I*/             SD_P0,
/*140*/ /*F2L*/             SD_P1,
        /*F2D*/             SD_P1,
        /*D2I*/             SD_M1,
        /*D2L*/             SD_P0,
        /*D2F*/             SD_M1,
        /*I2B*/             SD_P0,
        /*I2C*/             SD_P0,
        /*I2S*/             SD_P0,
        /*LCMP*/            SD_M3,
        /*FCMPL*/           SD_M1,
/*150*/ /*FCMPG*/           SD_M1,
        /*DCMPL*/           SD_M3,
        /*DCMPG*/           SD_M3,
        /*IFEQ*/            SD_M1 | OP1_BO2,
        /*IFNE*/            SD_M1 | OP1_BO2,
        /*IFLT*/            SD_M1 | OP1_BO2,
        /*IFGE*/            SD_M1 | OP1_BO2,
        /*IFGT*/            SD_M1 | OP1_BO2,
        /*IFLE*/            SD_M1 | OP1_BO2,
        /*IF_ICMPEQ*/       SD_M2 | OP1_BO2,
/*160*/ /*IF_ICMPNE*/       SD_M2 | OP1_BO2,
        /*IF_ICMPLT*/       SD_M2 | OP1_BO2,
        /*IF_ICMPGE*/       SD_M2 | OP1_BO2,
        /*IF_ICMPGT*/       SD_M2 | OP1_BO2,
        /*IF_ICMPLE*/       SD_M2 | OP1_BO2,
        /*IF_ACMPEQ*/       SD_M2,
        /*IF_ACMPNE*/       SD_M2,
        /*GOTO*/            SD_P0 | OP1_BO2 | NO_FALLTHROUGH,
        /*JSR*/             SD_P0 | OP1_JSR,
        /*RET*/             SD_P0 | OP1_LV1 | NO_FALLTHROUGH,
/*170*/ /*TABLESWITCH*/     SD_M1 | OP1_TABLESWITCH,
        /*LOOKUPSWITCH*/    SD_M1 | OP1_LOOKUPSWITCH,
        /*IRETURN*/         SD_0 | NO_FALLTHROUGH,
        /*LRETURN*/         SD_0 | NO_FALLTHROUGH,
        /*FRETURN*/         SD_0 | NO_FALLTHROUGH,
        /*DRETURN*/         SD_0 | NO_FALLTHROUGH,
        /*ARETURN*/         SD_M1 | NO_FALLTHROUGH,
        /*RETURN*/          SD_0 | NO_FALLTHROUGH,
        /*GETSTATIC*/       SD_GETSTATIC | OP1_CP2,
        /*PUTSTATIC*/       SD_PUTSTATIC | OP1_CP2,
/*180*/ /*GETFIELD*/        SD_GETFIELD | OP1_CP2,
        /*PUTFIELD*/        SD_PUTFIELD | OP1_CP2,
        /*INVOKEVIRTUAL*/   SD_INVOKEVIRTUAL | OP1_CP2,
        /*INVOKESPECIAL*/   SD_INVOKESPECIAL | OP1_CP2,
        /*INVOKESTATIC*/    SD_INVOKESTATIC | OP1_CP2,
        /*INVOKEINTERFACE*/ SD_INVOKEINTERFACE | OP1_CP2 | OP2_SB | OP3_SB,
        /*UNUSED*/          INVALID_OPCODE,
        /*NEW*/             SD_P1 | OP1_CP2,
        /*NEWARRAY*/        SD_P0 | OP1_UB,
        /*ANEWARRAY*/       SD_P0 | OP1_CP2,
/*190*/ /*ARRAYLENGTH*/     SD_P0,
        /*ATHROW*/          SD_M1 | NO_FALLTHROUGH,
        /*CHECKCAST*/       SD_P0 | OP1_CP2,
        /*INSTANCEOF*/      SD_P0 | OP1_CP2,
        /*MONITORENTER*/    SD_M1,
        /*MONITOREXIT*/     SD_M1,
        /*WIDE*/            INVALID_OPCODE,
        /*MULTIANEWARRAY*/  SD_MULTIANEWARRAY | OP1_CP2 | OP2_SB,
        /*IFNULL*/          SD_M1 | OP1_BO2,
        /*IFNONNULL*/       SD_M1 | OP1_BO2,
/*200*/ /*GOTO_W*/          SD_P0 | OP1_BO4,
        /*JSR_W*/           SD_P1 | OP1_BO4,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
/*210*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/*220*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/*230*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/*240*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/*250*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
    };

    public static final short[] WIDE_OPCODE_PROPERTIES = {
/*  0*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/*010*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/*020*/ INVALID_OPCODE,
        /*ILOAD*/ SD_P1 | OP1_LV2,
        /*LLOAD*/ SD_P2 | OP1_LV2,
        /*FLOAD*/ SD_P1 | OP1_LV2,
        /*DLOAD*/ SD_P2 | OP1_LV2,
        /*ALOAD*/ SD_P1 | OP1_LV2,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
/* 30*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/* 40*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/* 50*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        /*ISTORE*/ SD_M1 | OP1_LV2,
        /*LSTORE*/ SD_M2 | OP1_LV2,
        /*FSTORE*/ SD_M1 | OP1_LV2,
        /*DSTORE*/ SD_M2 | OP1_LV2,
        /*ASTORE*/ SD_M1 | OP1_LV2,
        INVALID_OPCODE, INVALID_OPCODE,
/* 60*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/* 70*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/* 80*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/* 90*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/*100*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/*110*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/*120*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/*130*/ INVALID_OPCODE, INVALID_OPCODE,
        /*IINC*/ SD_P0 | OP1_LV2 | OP2_SS,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
/*140*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/*150*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/*160*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE,
        /*RET*/ SD_P0 | OP1_LV2,
/*170*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/*180*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/*190*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/*200*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/*210*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/*220*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/*230*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/*240*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
/*250*/ INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE, INVALID_OPCODE,
        INVALID_OPCODE, INVALID_OPCODE,
    };
}
